/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef NMM_ICDDBImpl_HPP
#define NMM_ICDDBImpl_HPP

#include "nmm/nmm_prefix.hpp"

#include "nmm/comm/NMMObject.hpp"
#include "ICDDB.hpp"


#include "visibility.hpp"

namespace NMM
{

  class DLLEXPORT ICDDBImpl  : public virtual NMM::NMMObject { 
  public:
    ICDDBImpl() { addInterface(new ICDDB(*this)); registerEvents(); };

    virtual ~ICDDBImpl() {};

  protected:

    virtual Result setCDDBServer(const string& host, const nmm_int32& port) = 0;

    virtual string getTrackName(const nmm_int32& track) = 0;

    virtual string getDiscTitle() = 0;

    virtual string getDiscArtist() = 0;

    virtual void setCDDB(const nmm_bool& enabled) = 0;

    virtual bool getCDDB() = 0;


  private:
    void registerEvents();
  };

}

#include "nmm/nmm_suffix.hpp"

#endif
